package pl.edu.agh.kis.eis.ndl

import scala.util.Try

class SExpIntParser {
  final def parseIntQuery(q: String): List[Placeholder[Int]] = {
    val m = "\\([a-z0-9 ]+\\)".r
    val z = m.findAllIn(q.stripPrefix("(").stripSuffix(")"))
    z.map(termToPlaceholder).toList
  }

  def termToPlaceholder(q: String): Placeholder[Int] = {
    def parseConst(s: String) = Try(Const(s.toInt))
    def parseVar(s: String) = Try(Variable[Int](s))
    val stripped = q.stripPrefix("(").stripSuffix(")")
    def take(s: String): VarOrAtom[Int] = parseConst(s).orElse(parseVar(s)).get

    q.count(_ == ' ') match {
      case 0 => Placeholder(take(stripped))
      case 1 => Placeholder(stripped.split(' ').map(take): _*)
      case _ => throw new IllegalArgumentException("Only arity 0/1 terms are supported")
    }
  }
}
