package pl.edu.agh.kis.eis.ndl

import org.scalatest.{FlatSpec, Matchers}

class SExpParserSpec extends FlatSpec with Matchers {
  val parser = new SExpIntParser

  "Two variable placeholder" should "be returned" in {
    parser.termToPlaceholder("(a 1)") should equal(Placeholder(Variable("a"), Const(1)))
  }

  "Query" should "be parsed" in {
    parser.parseIntQuery("((x) (y z))") should equal(Seq(
      Placeholder[Int](Variable("x")),
      Placeholder[Int](Variable("y"), Variable("z"))))
  }
}
